:
# cde.sh
# version 3.1.3 Aug 25 11:21:02 PDT 1999
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0.10

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
RUNDATE=`/bin/date +%m%d%y%H%M%S`
SAVEFILES='/etc/dt/config/Xaccess /usr/dt/config/Xaccess'
XACONF='/etc/dt/config/Xaccess /usr/dt/config/Xaccess'

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro() {

cat << EOF

 $MYNAME - This script configures CDE to not accept XDMCP login connections
 from anyone (Assuming you didn't already turn off dtlogin)

 In order to do this we:

   2) Move /etc/dt/config/Xaccess to /etc/dt/config/Xaccess.$DATE (if it exists)
   3) Replace the Xaccess file with a minimal one allowing localhost etc...
   4) chmod the file to work with dt, X, etc...

EOF
}

Check() {

 if [ -f /usr/dt/config/Xaccess ]; then
    grep "^\!\*" /usr/dt/config/Xaccess >/dev/null 2>&-
    if [ $? -eq 0 ]; then
       t_echo 2 "   "
       t_echo 1 " /usr/dt/config/Xaccess is configured to not allow XDMCP login connections - PASSES CHECK 1"
    else
       t_echo 1 " /usr/dt/config/Xaccess allows XDMCP login connections. - FAILS CHECK 1"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation:  (cde.sh -f) If cde is installed and needed, configure CDE to"
        t_echo 3 "not allow Xaccess to /usr/dt/config/Xaccess to ensure X access is disabled from" 
        t_echo 3 "remote."
        t_echo 3 " "
        t_echo 3 "======================================================================== "

    fi
fi

if [ -f /etc/dt/config/Xaccess ]; then
   grep "^\!\*" /etc/dt/config/Xaccess >/dev/null 2>&-   
      if [ $? -eq 0 ]; then
        t_echo 2 "   "
        t_echo 1 " /etc/dt/config/Xaccess is configured to not allow XDMCP login connections - PASSES CHECK 2"
     else  
        t_echo 1 " /etc/dt/config allows XDMCP login connections. - FAILS CHECK 2"
     fi
fi

} # End Check

Fix() {

if [ ! -f /etc/dt/config/Xaccess ]; then
        (umask 022; mkdir -p /etc/dt/config)
cat << EOF >/etc/dt/config/Xaccess
# Titan modification                                          
# disable all XDMCP connections                               
#
!*                                                            
EOF

fi

if [ -f /etc/dt/config/Xaccess ] ; then
   cp /etc/dt/config/Xaccess /etc/dt/config/Xaccess-preTitan-${RUNDATE}
          mv /etc/dt/config/Xaccess /etc/dt/config/Xaccess.$RUNDATE
  t_echo 2 "Saving /etc/dt/config/Xaccess"
cat << EOF >/etc/dt/config/Xaccess
# Titan modification
# disable all XDMCP connections
#
!*
EOF

fi

# same as above for  /usr/dt/config/Xaccess

 
if [ ! -f /usr/dt/config/Xaccess ]; then
        (umask 022; mkdir -p /etc/dt/config)
cat << EOF >/usr/dt/config/Xaccess
# Titan modification
# disable all XDMCP connections
#
!*
EOF
 
fi
 
if [ -f /usr/dt/config/Xaccess ] ; then
          cp /usr/dt/config/Xaccess /usr/dt/config/Xaccess-preTitan-$RUNDATE
          mv /usr/dt/config/Xaccess /usr/dt/config/Xaccess.$RUNDATE
  t_echo 2 "Saving /usr/dt/config/Xaccess"
cat << EOF >/usr/dt/config/Xaccess
# Titan modification
# disable all XDMCP connections
#
!*
EOF
 
fi

} # End Fix
 

action=$1
case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
 	 Fix
	;;
	-[Vv]*)
	 Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
