:
# routed.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
RUNDATE=`/bin/date +%m%d%y%H%M%S`
SAVEFILES='/usr/sbin/routed /etc/rc.tcpip'
RTECOMM='/usr/sbin/routed'
RTECONFIG='/etc/rc.tcpip'
OS=`uname -r`
ORIG="orig"

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF

 $MYNAME : This script configures routed to run in quiet mode. 
 In order to do this we check in /etc/rc.tcpip for startup with '-q'
 flag.  Here is how...

   1) Check /etc/rc.tcpip to see if /usr/sbin/routed is enabled 
   2) If it is enabled what args does it have, look for '-q'
   3) If not '-q' then append this as the first arg after routed
      on the startup line in /etc/rc.tcpip 

EOF
}


Check() {

 if [ -f /etc/rc.tcpip ]; then
     ISROUTE=`grep ${RTECOMM} ${RTECONFIG} | grep -v "#"`
     # debug
     # echo "Found: ${ISROUTE}"
	if [ -z "$ISROUTE" ]; then
         t_echo 0 "	Route daemon not started in ${RTECONFIG} - PASSES CHECK"
	  exit 0
         else
          ISQUIET=`grep ${RTECOMM} ${RTECONFIG} | grep -v "#" | grep "\-q"`
          if [ -n "$ISQUIET" ]; then
	   # debug
	   # echo "Quiet mode: ${ISQUIET}"
           t_echo 0 "	Route daemon does not advertise routes - PASSES CHECK"
	   exit 0
          else
           t_echo 0 "	Route daemon enabled, not quiet - FAILS CHECK..."
	   exit 1
          fi
        fi
	else
     t_echo 0 "	Route daemon does not advertise routes - PASSES CHECK"
     exit 1
 fi

} # End Check


Fix() {

 if [ -f /etc/rc.tcpip ]; then
   cp ${RTECONFIG} ${RTECONFIG}-preTitan-${RUNDATE}
     ISROUTE=`grep ${RTECOMM} ${RTECONFIG} | grep -v "#"`
     # debug
     # echo "Found: ${ISROUTE}"
	if [ -z "$ISROUTE" ]; then
         t_echo 0 "	Route daemon not started in ${RTECONFIG} - PASSES CHECK"
	  exit 0
         else
          ISQUIET=`grep ${RTECOMM} ${RTECONFIG} | grep -v "#" | grep "\-q"`
          if [ -n "$ISQUIET" ]; then
	   # debug
	   # echo "Quiet mode: ${ISQUIET}"
           t_echo 0 "	Route daemon does not advertise routes - PASSES CHECK"
	   exit 0
          else
           t_echo 0 "	Route daemon enabled, not quiet - FAILS CHECK..."
	   t_echo 0 "	Fixing route entry, adding '-q' argument"

	ed - ${RTECONFIG} <<- EOEF
	/\/usr\/sbin\/routed
	g/^start \/usr\/sbin\/routed/s/$/ -q/g
	w
	q
	!
	EOEF
	
	   exit 1
          fi
        fi
	else
     t_echo 0 "	Route daemon does not advertise routes - PASSES CHECK"
     exit 1
 fi



} # End Fix


action=$1
case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
 	 Fix
	;;
	-[Vv]*)
	 Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
