:
#
# version 3.0.1 Tue Dec  1 09:23:31 PST 1998 bpowell
# version 3.0.3 Tue Fri Jan  8 12:42:25 PST 1999 bpowell; for FILE loop in Fix()

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
#

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`

OS=`uname -r`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {
cat << EOF

 This changes the system configuration to shorten the ARP expiration timer 
 to one minute instead of the default 20 minutes. This stops some of the
 ARP hijacking, ARP spoofing attacks. A better solution is still to use
 encrypted sessions, as they are harder to hijack/spoof.

 The program modifies /etc/rc.d/rc2.d/S??inet adding in the lines:

	ndd -set /dev/ip ip_ire_flush_interval 60000    /* 1 min */
	ndd -set /dev/arp arp_cleanup_interval 60000    /* 1 min */


EOF

}

Fix() {
	if [ -f /etc/rc.d/rc2.d/S??inet -o /etc/rc.d/rc3.d/S??inet ]; then
	for FILE in `ls /etc/rc.d/rc*.d/S??inet`
	do
	egrep '(ip_ire_flush_interval|arp_cleanup_interval)' $FILE >/dev/null 2>&-

	if [ $? -eq 0 ]; then
   	t_echo 2 "Entries for ARP in S??inet exist - PASSES CHECK"
 	else
   	t_echo 2 "Entries for ARP in S??inet do not exist - Fixing "

        t_echo 0 " Adding lines"
	t_echo 0 " ndd -set /dev/ip ip_ire_flush_interval 60000"
   	t_echo 0 " ndd -set /dev/arp arp_cleanup_interval 60000"
   	t_echo 0 " to /etc/rc.d/rc2.d/S??inet"
   	t_echo 0 "    "

ed - $FILE <<- !
a
	ndd -set /dev/ip ip_ire_flush_interval 60000
.
w
a
	ndd -set /dev/arp arp_cleanup_interval 60000
.
w
q
!
fi
done
fi
}

Check() {
if [ -f /etc/rc.d/rc2.d/S??inet ]; then
  t_echo 2 "    "
  t_echo 2 "    Checking for ARP timers in /etc/rc.d/rc2.d/S??inet"
  t_echo 2 "    "
  egrep '(ip_ire_flush_interval|arp_cleanup_interval)' /etc/rc.d/rc2.d/S??inet >/dev/null 2>&-
  if [ $? -eq 0 ]; then
  t_echo 2 "    "
  t_echo 2 "        ARP timers have been set - PASSES CHECK"
  t_echo 2 "    "
  else
  t_echo 0 "        ARP timers are not set - FAILS CHECK"
  t_echo 2 "    "
 fi
 else
  t_echo 2 "No file /etc/rc.d/rc2.d/S??inet found - FAILS CHECK"
fi
}

action=$1
case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Check
	Fix
	;;
	-[Vv]*)
	Check
	;;
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac


# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/etc/rc.d/rc2.d/S??inet'
