:
#
# version 3.0.5 Tue Feb 16 12:58:21 PST 1999 This module was contributed
# by Jason R. Rhoads mailto:jasonr@net.com 

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# contributed by <jason.rhoads@sabernet.net>

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF

 This program sets BANNER="" in /etc/default/telnetd so that the
 Solaris version is not displayed before the login prompt.

EOF
}

#
# Fix it
#
Fix() {

 grep "^BANNER=\"\"" /etc/default/telnetd > /dev/null 2>&-
 if [ ! -f /etc/default/telnetd -o $? -eq 1 ]; then
    if [ -f /etc/default/telnetd ]; then
      t_echo 1 "Removing telnetd banner - telnetd saved as telentd.ORIG.$DATE"
      cp /etc/default/telnetd /etc/default/telnetd.ORIG.$DATE
ed - /etc/default/telnetd << EOEF
g/^BANNER=/d
w
q
EOEF
    else
      t_echo 1 "Creating /etc/default/telnetd..."
      touch /etc/default/telnetd 
    fi 

	echo "BANNER=\"\"" >> /etc/default/telnetd
    chmod 444 /etc/default/telnetd

 fi

}

Verify() {

 grep "^BANNER=\"\"" /etc/default/telnetd > /dev/null 2>&-
 if [ ! -f /etc/default/telnetd -o $? -eq 1 ]; then
   t_echo 1 "telnet banner not disabled - FAILS CHECK"
 else
   t_echo 2 "telnet banner disabled - PASSES CHECK"
 fi
   exit 1
}

#
# Main section here

action=$1
case $action in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	  Fix
	 ;;
	 -[Vv]*)
	  Verify
	 ;;
	 *)
 	 t_echo 1 " "
	 t_echo 1 "        ERROR:Invalid arg $action"
	 t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 	 t_echo 1 " "
 	;;
esac


# List all files to save prior to changes this modules might make.
# Syntax is SAVEFILES='foo bar foobar'
#
SAVEFILES='/etc/default/telnetd'
