:
# inetd_flags.sh 
# Titan version 4.0 Thu Jan 25 11:52:14 PST 2001

umask 022
# This tools suite was writen by and is copyrighted by Brad Powell, Matt
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998
# with input from Casper Dik, and Alec Muffet.
# Basic skeleton script modified for FreeBSD.
# Derek Werthmuller 6/25/2000
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution.


# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`
HOST=`uname -n`
DATE=`/bin/date +%Y%m%d%H%M`
SAVEFILES='/etc/rc.conf'

. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {

cat << EOF
 $MYNAME - This program copies /etc/inetd.conf to /etc/inetd.conf.ORIG-DATE. 
 Then makes an addition to /etc/rc.conf to increase the number of times a
 service can be invoked in one minute.(the default is 256- 1024 sounds more
 reasonable adjust as needed)
 change RATE=1024 to adjust number of times service can be invoked.
 NOTE: This changes inetd_flags, if you have existing flags that you
 	want to keep, make changes to script as needed.
 
EOF

}
RATE='1024'

Fix() {

 if [ -f /etc/rc.conf  ]; then
  t_echo 2 " File /etc/rc.conf exists - Backing up to rc.conf.${DATE}"
  cp /etc/rc.conf /etc/rc.conf.${DATE}
 
 else
  t_echo 2 " /etc/rc.conf doesn't exist Creating.. "
  touch /etc/rc.conf
 fi

 t_echo 0 " Turning of the number of invocations for services.."
 t_echo 0 " The original version is saved as /etc/rc.conf.${DATE}"

 ed - /etc/rc.conf <<-!
g/^inetd_flags/s/^inetd_flags/#\ inetd_flags/g
/sysinstall
a
.
a
inetd_flags="-R 1024"   # set to "-R 256" for default  .
.
w
q
!

 t_echo 2 " Changing /etc/rc.conf to mode 644 ..."

}


Check() {

 if [ -f /etc/rc.conf ]; then
  t_echo 2 " File /etc/rc.conf exists - Checking..."
 else
  t_echo 1 "ERROR     could not find /etc/rc.conf"
  exit 1
 fi

if  grep -i '^inetd_flags *= *"-R 1024"' /etc/rc.conf
  then
  t_echo 2 "Passes check invocations has been increased."
else
  t_echo 1 "FAILS check   default inetd_flags"
fi

}

action=$1
        case ${action} in
	-[Ii]*)
	Intro
	;;
         -[Ff]*)
        Fix
        ;;
        -[Vv]*)
        Check
        ;;
        *)
        t_echo 1 " ERROR - Invalid arg $action"
        t_echo 1 " ERROR - Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
        ;;
        esac

