:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`
HOST=`uname -n`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh
 
Intro() {

cat << EOF

 This program looks to see if /etc/hosts.equiv exists. If run 
 in verify mode it then verifies that there are no '+' characters
 in the file and reports which, if any, hosts are allowed access.

 For all hosts allowed access, other than a '+' character,
 the host line is modified to reflect a non-compliant
 name service pattern such as 'foo' moved to '._-foo'
 and should subsequently be reviewed prior to allowing
 the entry to continue exist in /etc/hosts.equiv for
 the purposes of access control.

 If run in Fix mode it simply removes any  '+' entries

EOF

}

FixHostsEquiv() {

if  [ -f /etc/hosts.equiv -a -s /etc/hosts.equiv ]; then
      t_echo 0 " /etc/hosts.equiv exists and is not empty. Saving a copy..."
      /bin/cp /etc/hosts.equiv /etc/hosts.equiv.ORIG.$DATE

        if grep -s "^+$" /etc/hosts.equiv
        then
	ed - /etc/hosts.equiv <<- !
	g/^+$/d
	w
	q
	!
        fi
else
        t_echo 2 "        No /etc/hosts.equiv -  PASSES CHECK"
	exit 1
fi

}


CheckHostsEquiv() {

if  [ -s /etc/hosts.equiv ]; then
      t_echo 1 " /etc/hosts.equiv exists and is not empty - Checking..."

      for ENTRY in `cat /etc/hosts.equiv | grep -v "#"`
        do
        grep -s "^+$ENTRY$" /etc/hosts.equiv >/dev/null 2>&-
	if [ $? -ne 0 ]; then
		t_echo 0 "       Found $ENTRY - Run $MYNAME -F to REPAIR"
        fi
       done
else
        t_echo 2 "       No /etc/hosts.equiv -  PASSES CHECK"
	exit 1
fi

}


action=$1
        case ${action} in
	-[Ii]*)
	Intro
	;;
         -[Ff]*)
        FixHostsEquiv
        ;;
        -[Vv]*)
	CheckHostsEquiv
        ;;
        *)
        t_echo 1 "       ERROR:Invalid arg $action"
        t_echo 1 "       ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
        ;;
        esac
