:
# file-own.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# rev 3.0.1 Tue Oct 13 10:49:04 PDT 1998
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/usr/bin:/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
CONTENT=/var/sadm/install/contents
SAVEFILES='/var/sadm/install/contents'
OS=`uname -r`
HOST=`uname -n`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro() {

cat << EOF

 $MYNAME - This utility will modify permissions in /etc, /usr, /sbin
 and /opt to something closer to a secure Unix operating system 
 configuration. 
 Also changes some file permissions so that becoming "bin" or whatever
 doesn't mean you can plant a trojan for root to step on.
 Most of this is redundant to the fix-modes that you will run
 later but this helps a little up front....

EOF

}

Fix() {
	DIRLIST1="/usr /sbin"
	DIRLIST2="/usr /sbin /etc /opt"
	for DIR in $DIRLIST1
	do
	t_echo 2 " Changing $DIR ownership"
	find $DIR -fstype ufs -mount -user bin -print | xargs chown root 2>&-
	done

	for DIR2 in $DIRLIST2
	do
	t_echo 2 " Changing $DIR2 group permissions"
	find $DIR2 -fstype ufs -mount -group bin -perm -020 -print | xargs chmod g-w 2>&-
	done

}

Check() {

DIRLIST1="/usr /sbin"
DIRLIST2="/usr /sbin /etc /opt"
	for DIR in $DIRLIST1
	do
	t_echo 2 " Checking $DIR file ownership"
	find $DIR -fstype ufs -mount -user bin -print > ${TITANHOME}/tmp/$DIR.plist.$HOST
	OWN=`wc -l  ${TITANHOME}/tmp/$DIR.plist.$HOST | awk '{print $1}'` 2>&-
	if [ $OWN -ne 0 ] ; then
	STATUS="FAILS CHECK"
	else
	STATUS="PASSES CHECK"
	fi
 	t_echo 0 " Found $OWN files in $DIR that should be root owned - $STATUS"
	rm  ${TITANHOME}/tmp/$DIR.plist.$HOST
	done

	for DIR2 in $DIRLIST2
        do
	t_echo 2 " Checking $DIR2 group permissions"
	find $DIR2  -fstype ufs -mount -group bin -perm 020 -print > ${TITANHOME}/tmp/$DIR2.glist.$HOST 2>&-
	OWN=`wc -l  ${TITANHOME}/tmp/$DIR2.glist.$HOST | awk '{print $1}'` 2>&-
	if [ $OWN -ne 0 ] ; then
	STATUS="FAILS CHECK"
	else
	STATUS="PASSES CHECK"
	fi
	t_echo 0 " Found $OWN files in $DIR2 that should be set group g-w - $STATUS"
	rm  ${TITANHOME}/tmp/$DIR2.glist.$HOST
	done

}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "         ERROR:Invalid arg $action"
        t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac

