:
# nuke dtlogin.sh
# version 4.0 Wed Feb 16 08:33:18 PST 2000

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S73nfs.client'

OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro() {

cat << EOF
 $MYNAME : This program simply renames S73nfs.client to s73nfs.client so that
 NFS client side services are not started at system boot.

EOF

}

Fix() {

if [ -f /etc/rc2.d/S73nfs.client ]; then
   mv /etc/rc2.d/S73nfs.client /etc/rc2.d/s73nfs.client
  t_echo 2 "        Moved /etc/rc2.d/S73nfs.client to /etc/rc2.d/s73nfs.client"
else
  t_echo 1 "        NFS Client side support doesn't start at boot - PASSES CHECK" 
fi

}


Check() {

if [ -f /etc/rc2.d/S73nfs.client ]; then
  t_echo 0 "         File /etc/rc2.d/S73nfs.client exists.- FAILS CHECK"
  else
  t_echo 1 "         NFS Client support not started at boot time - PASSES CHECK "
fi

}


action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac
#finis
