:
# powerd.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/default/sys-suspend'
OS=`uname -r`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

case "`uname -r`" in
5.[678]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is Only needed on Solaris 2.6 and newer "
        exit 1;;
esac


# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro () {

cat << EOF

  $MYNAME :Script to change power management to be only runable by root

EOF

}

Fix() {

if [ -f /etc/default/sys-suspend ] ; then

	cp /etc/default/sys-suspend /etc/default/sys-suspend.ORIG.$DATE
	# since we are here, why don't we chmod /usr/openwin/bin/sys-suspend
        /bin/chmod 0755 /usr/openwin/bin/sys-suspend

	grep -s "PERMS=console-owner" /etc/default/sys-suspend >/dev/null 2>&-
	if [ $? -eq 0 ]; then
           t_echo 2 "         Power management being set to be run by root only  "
		ed - /etc/default/sys-suspend <<- !
			g/^PERMS=console-owner/s//PERMS=-/
			w
			q
		!
	fi
fi

}

Check() {

if [ -f /etc/default/sys-suspend ] ; then
grep -s "PERMS=console-owner" /etc/default/sys-suspend >/dev/null 2>&-
        if [ $? -eq 0 ]; then
           t_echo 0 "        Power management not set to be run by root  - FAILS CHECK "

	else
           t_echo 1 "         Power management is set to only be runnable by  root  - PASSES CHECK"
	fi
fi

}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
	;;
	esac

