:
# keyserv2.9.sh
# version 4.0.BETA4 solaris 9 version June 16, 2002

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2002
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
#

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
OS=`uname -r`
SAVEFILES='/etc/default/keyserv'

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh
 
case "`uname -r`" in
5.[9]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is Only supported on Solaris 9 and newer "
        t_echo 1 "use keyserv.sh for older Solaris releases "
        exit 1;;
esac

Intro () {

cat << EOF

 $MYNAME -  Script to start keyserv with default "nobody" key disallowed. See
 "man keyserv" for more information. Modifies /etc/default/keyserv changing the
 default ENABLE_NOBODY_KEYS=YES to ENABLE_NOBODY_KEYS=NO

EOF

}

Fix() {
if [ -f /etc/default/keyserv ]; then
        grep "^ENABLE_NOBODY_KEYS=NO" /etc/default/keyserv
 if [ $? -eq 0 ]; then
        t_echo 0 " /etc/default/keyserv is running secure - Nothing to change"
	else
	cp /etc/default/keyserv /etc/default/keyserv.ORIG.$DATE 
	ed -s /etc/default/keyserv <<- EOF
	$
	a
	ENABLE_NOBODY_KEYS=NO
	.
	w
	q
EOF
 fi
fi

}

Check() {

if [ -f /etc/default/keyserv ]; then
	grep "^ENABLE_NOBODY_KEYS=NO" /etc/default/keyserv
 if [ $? -eq 0 ]; then
        t_echo 0 " /etc/default/keyserv is running secure - PASSES CHECK"
        t_echo 3 " "
	else
	t_echo 0 " Keyserv allows Nobody keys - FAILS CHECK"
 fi
fi

}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
 t_echo 1 "        ERROR:Invalid arg $action"
 t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 t_echo 1 " "
	;;
	esac

