:
# disable-cachefs.sh
# version 4.0 Beta4

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup

TITANHOME=`pwd`
export TITANHOME
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib:./lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S73cachefs.daemon /etc/rc2.d/S93cacheos.finish'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh

Intro () {

cat << EOF

 $MYNAME -  Script to keep cachefs Daemon from starting in the 
 /etc/rc2.d/S73cachefs.daemon file
 Takes advantage of the fact that /etc/rc?.d files that begin with a small "s"
 don't get started, thus we simply move S73cachefs.daemon to s73cachefs.daemon
 and S93cacheos.finish to s93cacheos.finish

EOF

}

Fix() {

if [ -f /etc/rc2.d/S73cachefs.daemon -o -f /etc/rc2.d/S93cacheos.finish ] ; then
      for FILE in `ls /etc/rc2.d/S??cache*`
       do
	cp -p $FILE  `echo $FILE | tr -s S s`.ORIG.$DATE 
	t_echo 2 " renaming origional $FILE to `echo $FILE | tr -s S s`.ORIG.$DATE"
	t_echo 2 " renaming $FILE to disable cachefs service"
	mv $FILE `echo $FILE | tr -s S s`
      done
fi

}

Check() {

if [ -f /etc/rc2.d/S??cache* ]; then

      for FILE in `ls /etc/rc2.d/S??cache*`
       do
	t_echo 0 " Cache Filesystem Service is enabled in ${FILE} - FAILS CHECK"
	done
	        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (nuke-cachefs.sh -f) The Cache Filesystem server daemon should be"
        t_echo 3 "disabled on all Firewalls, and most servers as it is easily spoofed, or can be"
        t_echo 3 "exploited from remote. Titan by default disables the cachefs."
        t_echo 3 " "
        t_echo 3 "======================================================================== "

	else
	t_echo 1 " Cache Filesystem is disabled from starting  - PASSES CHECK"
	fi
}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
        *) 
          t_echo 1 " " 
          t_echo 1 "        ERROR:Invalid arg $action" 
          t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntroduction/(V)erify/(F)ix" 
          t_echo 1 " " 
        ;; 
        esac 

